"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.invoke = void 0;
const execa = require("execa");
const executorPath_1 = require("./executorPath");
const invoke = (options) => __awaiter(void 0, void 0, void 0, function* () {
    const lambdaExecution = execa.node(executorPath_1.executorPath, ['--inherit'], {
        env: options.environment,
        extendEnv: false,
        stdio: ['ignore', 'inherit', 'inherit', 'pipe'],
    });
    lambdaExecution.send(options);
    const childPipe = lambdaExecution.stdio[3];
    childPipe.setEncoding('utf-8');
    let data = '';
    return new Promise((resolve, reject) => {
        const closeHandler = () => {
            const { result, error } = JSON.parse(data);
            if (error) {
                reject(error);
            }
            else if (typeof result === 'undefined') {
                resolve(null);
            }
            else {
                resolve(result);
            }
        };
        childPipe.on('data', (d) => {
            data += d;
        });
        childPipe.on('close', closeHandler);
        childPipe.on('end', closeHandler);
        childPipe.on('error', reject);
    });
});
exports.invoke = invoke;
//# sourceMappingURL=invoke.js.map